--
-- Specialization for Kuhn Discover XS
-- V1.0
-- @author  Lulu88520
-- @date  22/11/2015
-- Copyright (C)Lulu88520.
-- https://www.facebook.com/paulo5090r
--Kuhn Discover XS de Paulo5090r & Lulu88520 est mis à disposition selon les termes de la licence Creative Commons Attribution - Pas d'Utilisation Commerciale - Pas de Modification 4.0 International.
--Kuhn Discover XS by Paulo5090r & Lulu88520 is licensed under a Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License

discover = {};
discover.modDir = g_currentModDirectory;

function discover.prerequisitesPresent(specializations)
    return true;
end;

function discover:load(xmlFile)	
  self.levage = false;
    self.sendLevage = false;
	
	self.flexible = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.flexible#index"));
    setVisibility(self.flexible, false);
    self.flexibleDetach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.flexibleDetach#index"));
    setVisibility(self.flexibleDetach, true);
end;

function discover:delete()   
end;

function discover:readStream(streamId, connection)	
  self.levage = streamReadBool(streamId);
end;

function discover:writeStream(streamId, connection)
	streamWriteBool(streamId, self.levage); 
end;

function discover:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)   
end;

function discover:mouseEvent(posX, posY, isDown, isUp, button)
end;

function discover:keyEvent(unicode, sym, modifier, isDown)			
end;

function discover:update(dt)		
	if self.sendLevage ~= self.levage then
		self.sendLevage = self.levage;
		LevageEvent:sendEvent(self, self.levage);
	end;
	 if self:getIsActive() and self.isClient and self:getIsActiveForInput() then       
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
			self.levage = not self.levage;    
		end;    
	end;
	if self.levage then 
                self:setAnimationTime(1, self.animationParts[1].animDuration);
	else
		self:setAnimationTime(1, self.animationParts[1].startPosition);                                       
	end;
	if self.animationParts[1].currentPosition > 0.00001 and self.animationParts[1].currentPosition < 2300 then	
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;		
end;
end;

function discover:updateTick(dt)				
end;

function discover:draw()
if g_currentMission.showHelpText and self.isClient then
     if self.levage then
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PLIER_COVER"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2); 
	else
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("DEPLIER_COVER"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2); 
	end;
end; 	
end;

function discover:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
end;

function discover:getSaveAttributesAndNodes(nodeIdent) 
end;


function discover:onEnter()
 
end;

function discover:onLeave()
end;

function discover:onAttach()
setVisibility(self.flexible, true);
 setVisibility(self.flexibleDetach, false);
end;

function discover:onDetach()
setVisibility(self.flexible, false);
 setVisibility(self.flexibleDetach, true); 
end;

LevageEvent = {};
LevageEvent_mt = Class(LevageEvent, Event);

InitEventClass(LevageEvent, "LevageEvent");

function LevageEvent:emptyNew()
  local self = Event:new(LevageEvent_mt);
  self.className="LevageEvent";
  return self;
end;

function LevageEvent:new(object, levage)
  local self = LevageEvent:emptyNew();
  self.object = object;
  self.levage = levage;
  return self;
end;

function LevageEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId));
  self.levage = streamReadBool(streamId);
  self:run(connection);
end;

function LevageEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.levage);
end;

function LevageEvent:run(connection)
  self.object.levage = self.levage;  
  if not connection:getIsServer() then
    g_server:broadcastEvent(LevageEvent:new(self.object, self.levage), nil, connection, self.object);
  end;
end;

function LevageEvent:sendEvent(object, levage, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(LevageEvent:new(object, levage), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(LevageEvent:new(object, levage));
    end;
  end;
end;

if g_currentModName ~= "Kuhn_discover_xs" then
	while g_currentModName ~= "Kuhn_discover_xs" do
	print("Error: The mod must not be renamed. It must be called Kuhn_discover_xs.zip");
	print("Erreur: Le mods ne doit pas être renommé. Il doit être appelé Kuhn_discover_xs.zip");	
	end;
end;
